{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Graf.TTUBE.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Graf.TTUBE.RawType
import HROOT.Graf.TTUBE.FFI
import HROOT.Graf.TTUBE.Interface
import HROOT.Graf.TTUBE.Cast
import HROOT.Graf.TTUBE.RawType
import HROOT.Graf.TTUBE.Cast
import HROOT.Graf.TTUBE.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Graf.TShape.RawType
import HROOT.Graf.TShape.Cast
import HROOT.Graf.TShape.Interface
import HROOT.Core.TNamed.RawType
import HROOT.Core.TNamed.Cast
import HROOT.Core.TNamed.Interface
import HROOT.Core.TAttLine.RawType
import HROOT.Core.TAttLine.Cast
import HROOT.Core.TAttLine.Interface
import HROOT.Core.TAttFill.RawType
import HROOT.Core.TAttFill.Cast
import HROOT.Core.TAttFill.Interface
import HROOT.Core.TAtt3D.RawType
import HROOT.Core.TAtt3D.Cast
import HROOT.Core.TAtt3D.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITTUBE (TTUBE) where

instance () => ITShape (TTUBE) where

instance () => ITNamed (TTUBE) where
        setName = xform1 c_ttube_setname
        setNameTitle = xform2 c_ttube_setnametitle
        setTitle = xform1 c_ttube_settitle

instance () => ITAttLine (TTUBE) where
        getLineColor = xform0 c_ttube_getlinecolor
        getLineStyle = xform0 c_ttube_getlinestyle
        getLineWidth = xform0 c_ttube_getlinewidth
        resetAttLine = xform1 c_ttube_resetattline
        setLineAttributes = xform0 c_ttube_setlineattributes
        setLineColor = xform1 c_ttube_setlinecolor
        setLineStyle = xform1 c_ttube_setlinestyle
        setLineWidth = xform1 c_ttube_setlinewidth

instance () => ITAttFill (TTUBE) where
        setFillColor = xform1 c_ttube_setfillcolor
        setFillStyle = xform1 c_ttube_setfillstyle

instance () => ITAtt3D (TTUBE) where

instance () => ITObject (TTUBE) where
        clear = xform1 c_ttube_clear
        draw = xform1 c_ttube_draw
        findObject = xform1 c_ttube_findobject
        getName = xform0 c_ttube_getname
        isA = xform0 c_ttube_isa
        paint = xform1 c_ttube_paint
        printObj = xform1 c_ttube_printobj
        saveAs = xform2 c_ttube_saveas
        write = xform3 c_ttube_write
        write_ = xform0 c_ttube_write_

instance () => IDeletable (TTUBE) where
        delete = xform0 c_ttube_delete

newTTUBE ::
           (Castable c2 CString, Castable c1 CString, Castable c0 CString) =>
           c0 -> c1 -> c2 -> CFloat -> CFloat -> CFloat -> CFloat -> IO TTUBE
newTTUBE = xform6 c_ttube_newttube
